/*
 *  DataFromFiles.h
 *  LogitReg
 *
 *  Created by Youna Hu on 1/14/11.
 *  Copyright 2011 U of Michigan. All rights reserved.
 *
 */
#ifndef __DataFromFiles_h__
#define __DataFromFiles_h__

#include "StringArray.h"
#include "MathMatrix.h"
#include <vector>
#include <map>
#include "Error.h"
//#include "Subset012sbyMAF.h"

typedef std::map<String, int> map_IDAndValue;

class DataFromFiles{
private:
	Matrix x;
	Vector y;
	Matrix xLine; // used to store each line of the files 
	String fileEntry;
	StringArray fileToken;
	std::vector<String> indvsIDs;
	bool header, IDcolumns;
	int colSize,fileStep,nSample; // nSample is the rowSize
public:
	void Initializer(); 
	// we have assumed that header for files: inFileName, covFileName, indvIDFileName consistent
	// it could be that they are not consistent, more parameters will be needed 
	void Initializer(bool headerIn, bool IDcolumnsIn); 
	DataFromFiles();
	DataFromFiles(bool headerIn, bool IDcolumnsIn);
	// Files with no ID as the first column
	
	// Files with ID as the first column
	void IDReadAsString(String &indIDFileName);
	// file to vector  
	void File2Vector(String &inFileName, Vector &vecOut); // does not need to remap the order
	void File2Vector(String &inFileName, String &indvIDFileName, Vector &vecOut);
	// file to matrix 
	void File2Matrix(String &covFileName, Matrix &matOut); // does not need to remap the order 
	void File2Matrix(String &covFileName, String &indvIDFileName, Matrix &matOut);
	void PositionFile2Matrix(String &inFileName, Matrix &matOut); // this file takes care of chr X and chr Y
													 
	// getter functions
	std::vector<String> & GetIndvsIDs();
};

#endif